// Model of consumption of a car in dependence 
// on gas, revs and altitude
// - general model order
// ----------------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

load _data/dataKF.dat
dt=DataKF.dataOrig([1 4 8 15],1:10:10*500);

ord=2;
y=dt(1,:);
x=dt(2:4,:);
nd=length(y);

for i=1:size(x,1)
  x(i,:)=(x(i,:)-mean(x(i,:)))/stdev(x(i,:));
end

for t=(ord+1):nd
  Y(t,1)=y(t);
  xx=x(:,t)';
  for i=1:ord
    xx=[xx x(:,t-i)'];
  end
  X(t,:)=[xx 1];
end

th=inv(X'*X)*(X'*Y)

yp=X*th;

set(scf(),'position',[500 100 600 500])
plot([y' yp])

e=y'-yp;
SE=e'*e/nd
