// Prediction of daily traffic intnsity
// - attempt without daily course
// - even if the order is high, the results are no good
// ----------------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

load _data/dataTunel.dat

// DATA CONSTRUCTION
y=dt(1,((3*288+1):35*288));
yy=[];
for k=([1 2 3 4 5  8 9 10 11 12  15 16 17 18 19  22 23 24 25 26]+2)
  yy=[yy; y(((k-1)*288+1):(k*288))];
end
// averaging
yc=mean(yy,1);
// filtration (means from 5 values)
yf=([yc(1:286) 0 0]+[yc(1:287) 0]+yc+[0 yc(1:287)]+[0 0 yc(1:286)])/5;

// ESTIMATION
ord=5;
V=[];
for t=(ord+1):288
  Ps=y(t);
  for i=1:ord
    Ps=[Ps y(t-i)];
  end
  Ps=[Ps 1];
  V=V+Ps'*Ps;
end
Vyp=V(2:$,1);
Vp=V(2:$,2:$);
th=inv(Vp)*Vyp

// PREDICTION
np=15;
for t=(ord+1):288-np
  yi=y(1:t-1);                          // past y is just measured
  yi(t)=[yi((t-1):-1:t-ord) 1]*th;      // first partial pradiction
  for i=1:np
    yi(t+i)=[yi((t+i-1):-1:t+i-ord) 1]*th; // successive predictions
  end
  yp(t+np)=yi(t+np);                    // final value of prediction
end

// RESULTS
// prediction error variance
s=5:288;
e=y(s)-yp(s)';
SE=e*e'/288

// plot of y and its prediction
set(scf(),'position',[500 100 600 500])
plot(1:288,y(1:288),1:288,yp)
