// Simulation with dynamic discrete model 
// (controlled coin with memory)
// - test some pre-defined cases (e.g. y=1,0,1,0 etc.)
// - test different uncertainty in the model
exec("ScIntro.sce",-1),mode(0)

nd=20;

// y= 1   2
th=[.48 .52        //y1=1 u=1     parameters of discrete model
    .49 .51        //y1=1 u=2 
    .53 .47        //y1=2 u=1 
    .51 .49];      //y1=2 u=2 
y(1)=1;                            // initial condition
u=(rand(1,nd,'unif')>.2)+1;

// Simultion loop
for t=2:nd
  j=2*(y(t-1)-1)+u(t);
  py=th(j,:);                      // choice of the row of parameters
//  [xxx y(t)]=max(py);            // index with maximal probability
  y(t)=(rand(1,1,'unif')>py(1))+1; // output generation
end

// Result
plot(1:nd,y,'r:o')
set(gcf(),"position",[800 100 500 400])
set(gca(),"data_bounds",[0 nd+1 .9 2.1])
