function [La1,La2,typ]=quadEq(a1,a2)
  // [La1 La2 typ]=quadEq(a1,a2)   solution to 2nd order alg. eq.
  // La1, La2   solutions (for complex La1-real, La2-imag.)
  // typ        type of solution
  // a1, a2     coefficients of the equation
  //                x^2 + a1.x + a2 = 0

  D=a1^2-4*a2;        // discriminant
  if abs(D)<1e-8      // one double root
    La1=-a1/2;
    La2=La1;
    typ=2;
  elseif D>0          // two real roots
    La1=(-a1+sqrt(D))/2;
    La2=(-a1-sqrt(D))/2;
    typ=1;
  else                // two complex roots
    La1=-a1/2;        //  real part
    La2=sqrt(-D)/2;   //  imaginary part
    typ=3;
  end
endfunction
